routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('index');
})->name('home');

Route::get('/install', function () {
    return response()->download(public_path('download/BeadPsikotes.apk'));
})->name('install');


// API
Route::post('/api/register', 'RegisterController@store');
Route::post('/api/login', 'LoginController@store');
Route::group(['middleware' => 'auth:api', 'prefix' => 'api'], function () {
    Route::post('/user', 'UserController@show');
    Route::apiResource('/instansi', 'InstansiController');
    Route::resource('/question', 'QuestionController');
    Route::post('score/send', 'ScoreController@send');
    Route::post('pdf', 'PDFController@download');
});

// Web
Route::get('login', 'Dashboard\DashboardController@login')->name('login');
Route::post('login', 'Dashboard\DashboardController@store')->name('login-post');
Route::group(['middleware' => ['auth']], function () {
    Route::group(['prefix' => 'dashboard'], function () {
        Route::post('logout', 'Dashboard\DashboardController@destroy')->name('logout');
        Route::resource('buatcv', 'Dashboard\BuatCVController');
        Route::group(['middleware' => ['isAdmin'], 'prefix' => 'admin'], function () {
            Route::resource('user', 'Dashboard\Admin\UserController', ['as' => 'admin']);
            Route::post('settings/activate', 'Dashboard\Admin\SettingsController@activate', ['as' => 'admin'])->name('activate');
            Route::resource('settings', 'Dashboard\Admin\SettingsController', ['as' => 'admin']);
            Route::resource('instansi', 'Dashboard\Admin\InstansiController', ['as' => 'admin']);
            Route::resource('report', 'Dashboard\Admin\ReportController', ['as' => 'admin']);
            Route::resource('category', 'Dashboard\Admin\CategoryController', ['as' => 'admin']);
            Route::resource('question', 'Dashboard\Admin\QuestionController', ['as' => 'admin']);
        });
    });
    Route::resource('dashboard', 'Dashboard\DashboardController');
});

app/Http/Controllers/Dashboard/Admin/CategoryController.php
<?php

namespace App\Http\Controllers\Dashboard\Admin;

use App\Category;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;

class CategoryController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        //
        $category = Category::all();
        return view('dashboard.category.index')->with([
            'categories' => $category
        ]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
        return view('dashboard.category.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
        $category = new Category();
        $category->name = $request->name;
        $category->save();
        return redirect()->back()->with('success', 'Berhasil menambahkan kategori: <b>'. $category->name .'</b>');
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }
}

app/Http/Controllers/Dashboard/Admin/InstansiController.php
<?php

namespace App\Http\Controllers\Dashboard\Admin;

use App\Instansi;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;

class InstansiController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        //
        $instansis = Instansi::all();
        return view('dashboard.instansi.index')->with([
            'instansis' => $instansis
        ]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
        return view('dashboard.instansi.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
        $numbers = str_split((string)(int)microtime(true));
        shuffle($numbers);
        $rand = '';
        foreach (array_rand($numbers, 6) as $k) $rand .= $numbers[$k];
        $instansi = new Instansi();
        $instansi->kode = $rand;
        $instansi->nama = $request->nama;
        $instansi->save();
        return redirect()->back()->with('success', "Penambahan instansi berhasil");
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }
}

app/Http/Controllers/Dashboard/Admin/QuestionController.php
<?php

namespace App\Http\Controllers\Dashboard\Admin;

use App\Category;
use App\Question;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;

class QuestionController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        //
        if (!Category::all()->count()) {
            return redirect()->route('dashboard.category.create')->with('error', 'Tambah kategori terlebih dahulu');
        }
        $questions = Question::all();
        return view('dashboard.question.index')->with([
            'questions' => $questions
        ]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
        if (!Category::all()->count()) {
            return redirect()->route('dashboard.category.create')->with('error', 'Tambah kategori terlebih dahulu');
        }
        return view('dashboard.question.create')->with('categories', Category::all());
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
        $question = new Question();
        $question->soal = $request->soal;
        $question->opsi1 = $request->opsi1;
        $question->opsi2 = $request->opsi2;
        $question->opsi3 = $request->opsi3;
        $question->opsi4 = $request->opsi4;
        $question->opsi5 = $request->opsi5;
        $question->jawaban = $request->jawaban;
        $question->category_id = $request->category;
        $question->save();
        return redirect()->back()->with('success', 'Berhasil menambahkan soal #'.$question->id);
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }
}

app/Http/Controllers/Dashboard/Admin/ReportController.php
<?php

namespace App\Http\Controllers\Dashboard\Admin;

use App\Instansi;
use App\Score;
use App\User;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;

class ReportController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        //
        $instansis = Instansi::all();
        return view('dashboard.report.index')->with([
            'instansis' => $instansis
        ]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
        return redirect()->route('admin.report.show', ['id' => $request->instansi]);
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
        $users = User::whereHas('score', function ($q) use ($id){
            $q->where('instansi_id', $id);
        })->get();
        return view('dashboard.report.show')->with([
            'users' => $users
        ]);
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
        $user = User::find($id);
        $user->score()->delete();
        return redirect()->back()->with('success', 'Berhasil menghapus nilai');
    }
}

app/Http/Controllers/Dashboard/Admin/SettingsController.php
<?php

namespace App\Http\Controllers\Dashboard\Admin;

use App\Settings;
use Artisan;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;

class SettingsController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        //
        if (\Schema::hasTable('settings')){
            $active = Settings::where('config', 'active')->first();
            return view('dashboard.settings.index')->with([
                'active' => $active
            ]);
        }
        else return view('dashboard.settings.index');

    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
        switch ($request->action){
            case 'migrate':
                Artisan::call('migrate');
                break;
            case 'rollback':
                Artisan::call('migrate:rollback');
                break;
        }
        return redirect()->back()->with('success', Artisan::output());
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }

    public function activate(Request $request){
        $settings = Settings::where('config', 'active')->first();
        $settings->value = $request->active;
        $settings->save();
        if ($request->active == "1"){
            $status = 'success';
            $message = 'Server berhasil dinyalakan';
        }
        elseif ($request->active == "2"){
            $status = 'error';
            $message = 'Server dimatikan';
        }
        return redirect()->back()->with($status, $message);
    }
}

app/Http/Controllers/Dashboard/Admin/UserController.php
<?php

namespace App\Http\Controllers\Dashboard\Admin;

use App\Instansi;
use App\User;
use Hash;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Validator;

class UserController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        //
        $user = User::all();
        return view('dashboard.user.review')->with([
            'users' => $user
        ]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
        $instansi = Instansi::all();
        return view('dashboard.user.create')->with([
            'instansis' => $instansi
        ]);
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
        $validator = Validator::make($request->all(),
            [
                'nama' => ['required', 'string', 'max:255'],
                'email' => ['required', 'string', 'email', 'max:255', 'unique:users'],
                'password' => ['required', 'string', 'min:6'],
            ],
            [
                'nama.required' => 'Kolom nama harus di isi',
                'email.required' => 'Kolom email harus di isi',
                'email.unique' => 'Email sudah digunakan',
                'password.required' => 'Kolom password harus di isi',
            ]);
        if ($validator->passes()) {
                $user = User::create([
                    'name' => $request->nama,
                    'email' => $request->email,
                    'password' => Hash::make($request->password),
                ]);
                return redirect()->back()->with('success', 'Pendaftaran user baru: '. $user->name .' berhasil');
        }
        else{
            return redirect()->back()->with('success', implode(", ", $validator->errors()->all()));
        }
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
        if (\Auth::id() == $id){
            return redirect()->back()->with('error', 'Tidak bisa menghapus akun sendiri');
        }
        $user = User::find($id);
        $user->delete();
        return redirect()->back()->with('success', 'Berhasil menghapus user');
    }
}

resources/views/dashboard/user/create.blade.php
@extends('layouts.dashboard')

@section('title', 'User')

@section('content')
    <section class="content-header">
        <h1>Tambah User</h1>
        <ol class="breadcrumb">
            <li><a href="{{ route('user.index') }}"><i class="fa fa-dashboard"></i> User</a></li>
            <li>Tambah User</li>
        </ol>
        @if ($message = Session::get('success'))
            <div class="alert alert-success alert-dismissible">
                <button type="button" class="close" data-dismiss="alert" aria-hidden="true">&times;</button>
                {{ $message }}
            </div>
        @endif
    </section>
    <section class="content">
        <div class="row">
            <div class="col-md-12">
                <div class="box">
                    <div class="box-body">
                        <div class="row">
                            <div class="col-md-12">
                                <form class="form-horizontal" action="{{ route('user.store') }}" method="POST">
                                    @csrf
                                    <div class="box-body">
                                        <div class="form-group">
                                            <div class="col-sm-12">
                                                <label for="inputNama" class="col-sm-2 control-label">Nama User</label>
                                                <div class="col-sm-10">
                                                    <input type="text" class="form-control" id="inputNama" name="nama"
                                                           placeholder="Nama User">
                                                </div>
                                            </div>
                                        </div>
                                        <div class="form-group">
                                            <div class="col-sm-12">
                                                <label for="email" class="col-sm-2 control-label">Email User</label>
                                                <div class="col-sm-10">
                                                    <input type="email" class="form-control" id="email" name="email"
                                                           placeholder="Email User">
                                                </div>
                                            </div>
                                        </div>
                                        <div class="form-group">
                                            <div class="col-sm-12">
                                                <label for="password" class="col-sm-2 control-label">Password</label>
                                                <div class="col-sm-10">
                                                    <input type="password" class="form-control" id="password" name="password"
                                                           placeholder="Password">
                                                </div>
                                            </div>
                                        </div>
                                        <div class="form-group">
                                            <div class="col-sm-12">
                                                <div class="box-footer text-center">
                                                    <button type="submit" class="btn btn-info">Tambah User</button>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </form>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </section>
@endsection

resources/views/dashboard/user/review.blade.php
@extends('layouts.dashboard')
@section('title', 'Review User')
@section('customcss')
    <!-- DataTables -->
    <link rel="stylesheet" type="text/css" href="https://cdn.datatables.net/v/bs/jszip-2.5.0/dt-1.10.18/b-1.5.6/b-html5-1.5.6/b-print-1.5.6/datatables.min.css"/>
@endsection
@section('content')
    <section class="content-header">
        <h1>Review User <a href="{{ route('admin.user.create') }}" class="btn btn-primary">Tambah</a></h1>
        <ol class="breadcrumb">
            <li><a href="{{ route('admin.user.index') }}"><i class="fa fa-dashboard"></i> User</a></li>
            <li class="active">Review User</li>
        </ol>
        @if (($message = Session::get('success')) || $message = Session::get('error'))
            <div class="alert alert-{{ Session::get('success') ? 'success' : 'danger' }} alert-dismissible">
                <button type="button" class="close" data-dismiss="alert" aria-hidden="true">&times;</button>
                {{ $message }}
            </div>
        @endif
    </section>
    <section class="content">
        <div class="row">
            <div class="col-md-12">
                <div class="box">
                    <div class="box-body">
                        <div class="row">
                            <div class="col-md-12">
                                <table id="usersList" class="table table-bordered table-striped">
                                    <thead>
                                    <tr>
                                        <th>ID</th>
                                        <th>Nama</th>
                                        <th>Email</th>
                                        <th>Aksi</th>
                                    </tr>
                                    </thead>
                                    <tbody>
                                    @foreach ($users as $user)
                                        <tr>
                                            <td>{{$user->id}}</td>
                                            <td>{{$user->name}}</td>
                                            <td>{{$user->email}}</td>
                                            <td>
                                                <button type="button" class="btn btn-sm btn-danger" data-toggle="modal"
                                                        data-target="#modal-delete-{{ $user->id }}"><i class="fa fa-trash" aria-hidden="true"></i>
                                                </button>
                                                <div class="modal fade" id="modal-delete-{{ $user->id }}" style="display: none;">
                                                    <div class="modal-dialog">
                                                        <div class="modal-content">
                                                            <form action="{{ route('admin.user.destroy', ['id' => $user->id]) }}" method="POST">
                                                                @method('DELETE')
                                                                <div class="modal-header">
                                                                    <button type="button" class="close" data-dismiss="modal"
                                                                            aria-label="Close">
                                                                        <span aria-hidden="true">×</span></button>
                                                                    <h4 class="modal-title">Hapus User</h4>
                                                                </div>
                                                                <div class="modal-body">
                                                                    @csrf
                                                                    Apakah anda yakin untuk menghapus akun ini?
                                                                </div>
                                                                <div class="modal-footer">
                                                                    <button type="button" class="btn btn-default"
                                                                            data-dismiss="modal">Batal
                                                                    </button>
                                                                    <button type="submit" class="btn btn-primary">Delete User</button>
                                                                </div>
                                                            </form>
                                                        </div>
                                                    </div>
                                                </div>
                                            </td>
                                        </tr>
                                    @endforeach
                                    </tbody>
                                </table>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </section>
@endsection
@section('customscript')
    <!-- DataTables -->
    <script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/pdfmake/0.1.36/pdfmake.min.js"></script>
    <script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/pdfmake/0.1.36/vfs_fonts.js"></script>
    <script type="text/javascript" src="https://cdn.datatables.net/v/bs/jszip-2.5.0/dt-1.10.18/b-1.5.6/b-html5-1.5.6/b-print-1.5.6/datatables.min.js"></script>
    <script>
        $(function () {
            /*$('#usersList').DataTable( {
                buttons: [
                    'copy', 'excel', 'pdf'
                ]
            })*/
            var table = $('#usersList').DataTable( {
                buttons: [
                    {
                        extend: 'copy',
                        exportOptions: {
                            columns: 'th:not(:last-child)'
                        }
                    },
                    {
                        extend: 'excel',
                        exportOptions: {
                            columns: 'th:not(:last-child)'
                        }
                    },
                    {
                        extend: 'pdf',
                        exportOptions: {
                            columns: 'th:not(:last-child)'
                        }
                    }
                ]
            } );

            table.buttons().container()
                .appendTo( $('.col-sm-6:eq(0)', table.table().container() ) );
        })
    </script>
@endsection